*xxbrowse.prg
*Copywrite: 23/October/1994
*Gordon Angus, 208 Canning Hwy, East Fremantle, Western Australia
********************************************************************
PROCEDURE xxbrowse
*28/7/94 GAA.  Screen generation skeleton for composite browse scrn

*Typical call is:-
*DO xxbrowse WITH ;
SCREEN depth,split,SCREEN WIDTH,'Title' AT TOP OF SCREEN,;
'Comments' AT BOTTOM OF SCREEN,BROWSE modifiers

*To add extra objects to top panel include a procedure {named 'tw_' plus
*the first five (or up to the 1st non blank) letters of the browse title
*or if there is no browse title then the 1st 5 of the database alias}
*in the calling routine and put all @..gets in there.
*ditto for updates but procedure name starts with 'ok_'
*eg do xxbrowse 0,0,0,' ',' ','fields abc,def title "All other Items"'
*@..gets are put in "tw_all",  update procedure is "ok_all"
*
*Read xxbrowse.txt

PARAMETERS xxdepth,split,xxwidth,lchdg,lcfoot,allelse
PRIVATE botspace,edge,botmedge,xxokq,dummy,lastplus,aftrplus,spcs,lctitlex,;
   lentitle,lctitlec,lastblk,xxdepth,xxwidth,split,lchdg,lcfoot,allelse,;
   extnsn,tw,upd,invisbtn

*set up environment
SET CONFIRM OFF
SET TALK OFF
SET SAFETY OFF

*-------------------------------------------

*apply defaults
IF TYPE('lchdg')#'C'
   *lchdg= 'TITLE STRING'
   lchdg=ALIAS()
ENDIF
IF TYPE('lcfoot')#'C'
   *lcfoot='Bottom Line Notes Etc.'
   lcfoot=' '
ENDIF
IF (TYPE('xxdepth')='N' AND (xxdepth<12 OR xxdepth>SROWS()-1)) OR ;
   TYPE('xxdepth')#'N'
   xxdepth=SROWS()-.1
ENDIF
IF (TYPE('xxwidth')='N' AND (xxwidth<5 OR xxwidth>SCOLS()-1)) OR ;
   TYPE('xxwidth')#'N'
   xxwidth=SCOLS()-.1
ENDIF
IF (TYPE('split')='N' AND split=0) OR TYPE('split')#'N'
   split=xxdepth/3				&&location of top of data screen
ENDIF
split=IIF(split > xxdepth-7,xxdepth-7,split)
split=IIF(split<5,5,split)

IF TYPE('botspace')#'N'
   botspace=0				&&free lines below screen
ENDIF
botspace=IIF(botspace<0 OR botspace>15,1,botspace)

edge=1.5					&&width of raised edge down side data screen
botmedge=2				&&depth of bottom rail


*---------------------------------------------

*initialise flags and other variables
*update or quit flag
okq=0
*no-'topwindow' flag
ntwflg=.F.

*---------------------------------------------

*Define windows

*background window
DEFINE WINDOW w01 AT 0,0 TO xxdepth,xxwidth  ;
   FONT "MS Sans Serif", 8 COLOR RGB(,,,192,192,192)
MOVE WINDOW w01 CENTER

*data entry panel
*size of data entry panel
dpdepth=WROWS('w01')-botmedge-.4-split
dpdepth=ROUND(dpdepth,1)
dpwidth=WCOLS('w01')-2*(edge+.5)
*data entry frame
DEFINE WINDOW brsw1 FROM split,(edge+.5) SIZE dpdepth-.1,dpwidth-.3 ;
   IN WINDOW w01   FONT "MS Sans Serif", 8
*data entry window
DEFINE WINDOW brsw2 AT 0,0 SIZE dpdepth-2,WCOLS('brsw1')-5.2 ;
   IN WINDOW brsw1  FONT "MS Sans Serif", 8 SYSTEM GROW NOCLOSE

*header window
DEFINE WINDOW brsw3 FROM 1.8,.3 TO split-.4,WCOLS('w01')-.6 ;
   NONE IN WINDOW w01;
   FONT "MS Sans Serif", 8 COLOR RGB(,,,192,192,192)

*---------------------------------------------

*draw and activate main windows
ACTIVATE WINDOW w01
*chisel edges
DO ext_chis
DO ins_chis WITH split-.2,edge,WROWS()-botmedge-(split-.2),WCOLS()-2*edge
*add title
DO inchis WITH .5,4.6,1,WCOLS()-8
@ .5,4.8 SAY ' ' SIZE 1,WCOLS()-8 COLOR N/BG*
@ .5,4+(WCOLS()-8-TXTWIDTH(lchdg,'ms sans serif',8,'b'))/2 ;
   SAY lchdg FONT 'ms sans serif',8 STYLE 'b' COLOR N/BG*
*add footer
IF lcfoot>'       '
   DO inchis WITH WROWS()-1.6,4.5,1,WCOLS()-9
   @ WROWS()-1.6,4.8 SAY ' ' SIZE 1,WCOLS()-9 COLOR W+/R
   @ WROWS()-1.6,4+(WCOLS()-10-TXTWIDTH(lcfoot,'ms sans serif',8))/2 ;
      SAY lcfoot FONT 'ms sans serif',8 STYLE 'b' COLOR W+/R
ENDIF

ACTIVATE WINDOW brsw1
ACTIVATE WINDOW brsw3
@ 0,.1 TO WROWS(),.1 PEN 2 COLOR RGB(255,255,255,255,255,255)

*---------------------------------------------

*Get name of browse window
*determine if 'allelse' contains a title term. If so get 1st word of title.
IF  TYPE('allelse')='C' AND 'title'$LOWER(allelse)
   *get rid of the beginning
   lctitlex=LTRIM(SUBSTR(allelse,ATC('title ',allelse)+5))
   *get rid of the end
   IF '+'$lctitlex
      *find the length of the title expression
      lastplus=RAT('+',lctitlex)
      aftrplus=SUBSTR(lctitlex,lastplus+1)
      spcs=LEN(aftrplus)-LEN(LTRIM(aftrplus))
      lastblk=IIF(AT(' ',LTRIM(aftrplus))=0,;
         LEN(LTRIM(aftrplus)),AT(' ',LTRIM(aftrplus))-1)
      lentitle=lastplus+spcs+lastblk
      *get rid of the leftover
      lctitlex=LEFT(lctitlex,lentitle)
      *add final quotation mark if necessary
      IF (LEFT(lctitlex,1)='"' OR LEFT(lctitlex,1)="'") AND ;
            RIGHT(lctitlex,1)#LEFT(lctitlex,1)
         lctitlex=lctitlex+LEFT(lctitlex,1)
      ENDIF
   ELSE
      lctitlex=SUBSTR(lctitlex,1,;
         IIF(AT(' ',lctitlex)=0,LEN(lctitlex),AT(' ',lctitlex)-1))
      *add final quotation mark if necessary
      IF (LEFT(lctitlex,1)='"' OR LEFT(lctitlex,1)="'") AND ;
            RIGHT(lctitlex,1)#LEFT(lctitlex,1)
         lctitlex=lctitlex+LEFT(lctitlex,1)
      ENDIF
   ENDIF
   *now find the first word of the converted title
   lctitlec=&lctitlex
   lctitlex=SUBSTR(lctitlec,1,;
      IIF(AT(' ',lctitlec)=0,LEN(lctitlec),AT(' ',lctitlec)-1))
ELSE
   lctitlex=ALIAS()
ENDIF

*---------------------------------------------

*define on-key to allow moving to browse via the programme
ON KEY LABEL alt+f12 ACTIVATE WINDOW (lctitlex)

*---------------------------------------------

*define and display top window objects
*define procedure name as 'tw_' + 1st 5 non-blank letters of the title/name
extnsn=IIF(LEN(lctitlex)>5,LEFT(lctitlex,5),lctitlex)
tw='tw_'+extnsn

invisbtn=0
xxokq=0
@ 0,0 GET invisbtn FUNCTION '*I ; '		&&used to kluge browse initiation

*look for procedure 'topwindow' in calling programme
ON ERROR DO ntwflg	&&if topwindow doesnt exist
DO &tw
ON ERROR &&do errhandl with lineno(),program()

@ .3,(WCOLS()-21)/2 GET xxokq FUNCTION '*HT OK;Cancel' SIZE 2,10 ;
   FONT 'ms sans serif',8 STYLE 'b'

*---------------------------------------------

*display the data entry panel
IF TYPE('allelse')='C'

   BROWSE WINDOW brsw2 IN WINDOW brsw1  NOWAIT SAVE &allelse
ELSE
   BROWSE WINDOW brsw2 IN WINDOW brsw1  NOWAIT SAVE
ENDIF

*---------------------------------------------

*stuff the keyboard to kludge initiation of browse
KEYBOARD '{rightarrow}{alt+f12}'

*do THE read
*(use correct browse window title)
READ CYCLE MODAL WITH (lctitlex)

*---------------------------------------------

*close off on-key statement used for moving to browse screen in the programme
ON KEY LABEL alt+f12
CLEAR TYPEAHEAD

*Update/close
IF xxokq=1
   *Update databases
   upd='ok_'+extnsn
   ON ERROR dummy=1
   DO &upd
   ON ERROR &&do errhandl with lineno(),program()
ENDIF

RELEASE WINDOWS w01,brsw1,brsw2,brsw3
*CLOSE DATABASES
CLEAR
SET SAFETY ON
*********************
PROCEDURE ntwflg
ntwflg=.T.
*********************
PROCEDURE gobrowse
KEYBOARD '{rightarrow}{alt+f12}'
*********************
PROCEDURE hidefoot
wcurr=WONTOP()
ACTIVATE WINDOW w01
@ WROWS()-1.6,4.8 SAY ' ' SIZE 1,WCOLS()-9 COLOR W+/R
ACTIVATE WINDOW (wcurr)

*********************
PROCEDURE showfoot
PARAMETER lcfoot2
IF TYPE('lcfoot2')#'C'
   lcfoot2=lcfoot
ENDIF

wcurr=WONTOP()
ACTIVATE WINDOW w01
*clear display
@ WROWS()-1.6,4.8 SAY ' ' SIZE 1,WCOLS()-9 COLOR W+/R
*write new text
@ WROWS()-1.6,4+(WCOLS()-20-TXTWIDTH(lcfoot2,'ms sans serif',8))/2 ;
   SAY lcfoot2 FONT 'ms sans serif',8 STYLE 'b' COLOR W+/R
ACTIVATE WINDOW (wcurr)

*********************
*Draws a chiselled thermometer window to accommodate 100 spaces
PROCEDURE thermo1
PARAMETER TITLE

DEFINE WINDOW thermo1 FROM 10,0 SIZE 5,70 NONE ;
   FONT 'ms sans serif',8 	COLOR RGB(,,,192,192,192)
MOVE WINDOW thermo1 CENTER
ACTIVATE WINDOW thermo1

IF TYPE('title')='C'
   @ .6,5 SAY TITLE FONT 'ms sans serif',8 STYLE 'b'
ENDIF

DO ext_chis
DO inchis WITH 2,5,1,60

*e.g.
*jj=space(100)
*kk=space(50)
*both lines below are the same length
*@ 2,5 say jj color n/bg*
*@ 3,5 say kk color n/w*  size 1,60

*********************
PROCEDURE dgbox   &&chiselled dialog box
*A re-arrangement of calling parameters, otherwise same as dgbox1.
PARAMETERS depth,WIDTH,atitle,NOTE
PRIVATE depth,WIDTH,atitle,NOTE

*release window dgbox in calling programme after use.

IF TYPE('depth')#'N'
   depth=10
ENDIF
IF TYPE('width')#'N'
   WIDTH=30
ENDIF
IF depth<6
   depth=10
ENDIF
IF WIDTH<6
   WIDTH=30
ENDIF
*adjust width if title is too wide
IF TYPE('ATITLE')='C'
   WIDTH=IIF(TXTWIDTH(atitle)+12>WIDTH,TXTWIDTH(atitle)+12,WIDTH)
ELSE
   atitle=' '
ENDIF


DEFINE WINDOW dgbox ;
   AT 5,5 SIZE depth,WIDTH ;
   FONT "MS Sans Serif", 8  ;
   COLOR RGB(,,,192,192,192) NONE

MOVE WINDOW dgbox CENTER

ACTIVATE WINDOW dgbox NOSHOW
DO out_chis WITH 0,0,WROWS(),WCOLS()
DO ins_chis WITH 3,4,WROWS()-2-3,WCOLS()-4-4
DO ins_chis WITH .4,4,1.5,WCOLS()-8
@ 0.71,4.8 SAY ' ' SIZE 1,WCOLS()-9.25 COLOR N/BG*
@ .71,4+(WCOLS()-9.25-TXTWIDTH(atitle,'ms sans serif',8,'b'))/2 ;
   SAY atitle FONT 'ms sans serif',8 STYLE 'b' COLOR N/BG*

IF TYPE('note')='C'
   @ 3.2,5 SAY NOTE FONT "MS Sans Serif",8 ;
      STYLE "BT" SIZE 3,WCOLS()-18
ENDIF

RETURN


******************************
PROCEDURE ext_chis
*draws a chiseled edge around active window
DO out_chis WITH 0,0,WROWS(),WCOLS()
******************************
PROCEDURE out_chis
*Outside Chisel

PARAMETERS r1,c1,depth,WIDTH

r2=r1+depth
c2=c1+WIDTH

@ r1,c1 TO r2,c1 ;
   PEN 1, 8 ;
   COLOR RGB(192,192,192,,,,)
@ r1,c1 TO r1,c2 ;
   PEN 1, 8 ;
   COLOR RGB(192,192,192,,,,)
@ r1+.1,c1+.1 TO r2-.1,c1+.1 ;
   PEN 2, 8 ;
   COLOR RGB(255,255,255,,,,)
@ r1+.1,c1+.2 TO r1+.1,c2-.2 ;
   PEN 2, 8 ;
   COLOR RGB(255,255,255,,,,)
*@ r2,c1 to r2,c2 pen 1, 8
*@ r1,c2 to r2,c2 pen 1, 8
@ r2-.2, c1+.2 TO r2-.2,c2-.2 PEN 2, 8 ;
   COLOR RGB(128,128,128,,,,)
@ r1+.2, c2-.5 TO r2-.2, c2-.5 PEN 2, 8 ;
   COLOR RGB(128,128,128,,,,)
@ r1,c1 TO r2,c2+.1 PEN 0, 8 STYLE '1'



************************
PROCEDURE ins_chis
PARAMETERS r1,c1,depth,WIDTH

r2=r1+depth
c2=c1+WIDTH

*Inside chisel
*top
@ r1,c1 TO r2,c1  PEN 2, 8 ;
   COLOR RGB(128,128,128,,,,)
@ r1+.15,c1+.4 TO r2-.15,c1+.4 ;
   PEN 1, 8

*left
@ r1,c1 TO r1,c2  PEN 2, 8 ;
   COLOR RGB(128,128,128,,,,)
@ r1+.15,c1+.4 TO r1+.15,c2-.4 ;
   PEN 1, 8

*bottom
@ r2-.15, c1+.2 TO r2-.15,c2-.2 PEN 2, 8 ;
   COLOR RGB(255,255,255,255,255,255)
@ r2-.15, c1+.4 TO r2-.15,c2-.4 PEN 0, 8 ;
   COLOR RGB(192,192,192,,,)
@ r2, c1 TO r2,c2 PEN 0, 8 ;
   COLOR RGB(128,128,128,,,,)

*right
@ r1,c2 TO r2,c2 PEN 1, 8 ;
   COLOR RGB(128,128,128,,,,)
@ r1+.2, c2-.4 TO r2-.2, c2-.4 PEN 2, 8 ;
   COLOR RGB(255,255,255,255,255,255)
@ r1+.2, c2-.4 TO r2-.2, c2-.4 PEN 0, 8 ;
   COLOR RGB(192,192,192,,,)

**************************
PROCEDURE inchis
*inside chisel for field
PARAMETERS r11,c11,depth,WIDTH

*depth=depth*1.1
*width=width*1.018
r1=IIF(r11>=.25,r11-.25,0)
c1=IIF(c11>=.6,c11-.6,0)
r2=r11+depth+.25
r2=IIF(r2>WROWS(),WROWS(),r2)
c2=c11+WIDTH+.4
c2=IIF(c2>WCOLS(),WCOLS(),c2)
depth=r2-r1
WIDTH=c2-c1

DO ins_chis WITH r1,c1,depth,WIDTH

****************
FUNCTION astart
PARAMETER x

IF USED(x)
   SELECT (x)
ELSE
   SELECT 0
   USE (x)
ENDIF

RETURN

*********************************
PROCEDURE errhandl  &&logs to file 1errlog.dbf
PARAMETERS lnline,lcprog
lcarea=ALIAS()
IF NOT FILE('1errlog.dbf')
   CREATE TABLE 1errlog (DATE D(8),TIME C(8),errnum N(5,0),errnote m)
ELSE
   =astart('1errlog')
ENDIF
APPEND BLANK
REPLACE DATE WITH DATE()
REPLACE TIME WITH TIME()
REPLACE errnum WITH ERROR()
REPLACE errnote WITH MESSAGE()+CHR(13)+MESSAGE(1)+CHR(13)+;
   'At line no '+LTRIM(STR(lnline,5,0))+;
   ' of programme '+lcprog+CHR(13)
SET SAFETY OFF
LIST MEMORY TO FILE 1errtemp.txt NOCONSOLE
APPEND MEMO errnote FROM 1errtemp.txt
LIST STATUS TO FILE 1errtemp.txt NOCONSOLE
APPEND MEMO errnote FROM 1errtemp.txt
IF RECCOUNT()>20
   DELETE FOR RECNO()<RECCOUNT()-20
   PACK
ENDIF
USE
IF lcarea>' '
   SELECT (lcarea)
ENDIF
RETURN
*****************
